package com.ruoyi.cai.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.cai.domain.UserMember;
import com.ruoyi.cai.dto.admin.vo.UserMemberAdminVo;
import com.ruoyi.cai.mapper.UserMemberMapper;
import com.ruoyi.cai.pay.MemberStatusEnum;
import com.ruoyi.cai.service.UserMemberService;
import com.ruoyi.common.core.domain.PageQuery;
import org.springframework.stereotype.Service;

/**
 * 会员管理Service业务层处理
 *
 * @author 77
 * @date 2023-12-21
 */
@Service
public class UserMemberServiceImpl extends ServiceImpl<UserMemberMapper, UserMember> implements UserMemberService {

    @Override
    public Page<UserMemberAdminVo> pageAdmin(PageQuery pageQuery, UserMemberAdminVo bo) {
        return baseMapper.pageAdmin(pageQuery.build(),bo);
    }

    @Override
    public UserMember getByUserId(Long userId) {
        return this.getOne(Wrappers.lambdaQuery(UserMember.class).eq(UserMember::getUserId,userId).last("limit 1"));
    }

    @Override
    public UserMember getNormalMember(Long userId){
        return this.getOne(Wrappers.lambdaQuery(UserMember.class).eq(UserMember::getUserId,userId)
                .eq(UserMember::getMemberStatus, MemberStatusEnum.NORMAL.getCode())
                .last("limit 1"));
    }

    @Override
    public void relieveMember(Long id) {
        this.update(Wrappers.lambdaUpdate(UserMember.class)
                .eq(UserMember::getId,id)
                .set(UserMember::getMemberStatus, MemberStatusEnum.FAIL.getCode()));
    }
}
